'use strict';

var lr$1 = require('@lezer/lr');
var highlight = require('@lezer/highlight');
var language$1 = require('@codemirror/language');
var autocomplete = require('@codemirror/autocomplete');

const highlighting = highlight.styleTags({
  'function local_var global_var': highlight.tags.definitionKeyword,
  'if else for while repeat until foreach return break continue x': highlight.tags.controlKeyword,
  'include': highlight.tags.moduleKeyword,
  'Identifier': highlight.tags.variableName,
  'ArgDecl/Identifier VarDecl/Identifier': highlight.tags.definition(highlight.tags.variableName),
  'FuncDecl/Identifier': highlight.tags.function(highlight.tags.definition(highlight.tags.variableName)),

  ArithOp: highlight.tags.arithmeticOperator,
  AssignOp: highlight.tags.definitionOperator,
  BitOp: highlight.tags.bitwiseOperator,
  CompareOp: highlight.tags.compareOperator,
  LogicOp: highlight.tags.logicOperator,
  UpdateOp: highlight.tags.updateOperator,
  Comment: highlight.tags.lineComment,
  Integer: highlight.tags.number,
  String: highlight.tags.string,
  '( )': highlight.tags.paren,
  '[ ]': highlight.tags.squareBracket,
  '{ }': highlight.tags.brace,
  ', ;': highlight.tags.separator
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,x:65, return:66, include:68, local_var:74, global_var:76, break:78, continue:80, if:92, else:94, for:98, while:106, repeat:110, until:112, foreach:116, function:120};
const parser$1 = lr$1.LRParser.deserialize({
  version: 14,
  states: "2xQYQPOOOOQO'#C`'#C`O!aQPO'#EXO!fQPO'#EXO#ZQPO'#DvOOQO'#Dv'#DvOOQO'#C_'#C_O$UQPO'#C_O%bQPO'#DWOOQO'#Ew'#EwO%iQPO'#DtOOQO'#Dt'#DtOOQO'#Dl'#DlQYQPOOO%nQPO'#DQO&hQPO'#C_O&oQPO'#DZO&tQPO'#D^O&oQPO'#DbO$^QPO'#DdO!aQPO'#DgO!aQPO'#DiO&yQPO'#C_OOQO,5:s,5:sO'OQPO'#DvOOQO'#Cz'#CzOOQO'#C{'#C{O%vQPO,5:aO'ZQPO'#CoOOQO,59Y,59YO%vQPO,58{O%vQPO,5;aOOQO'#Dp'#DpO'bQPO,59rOOQO,59r,59rOOQO,5:`,5:`OOQO-E7j-E7jO'iQPO'#EvO'tQPO'#EvOOQO,59l,59lO%vQPO'#CcO(PQQO'#EdO,bQQO'#EdOOQO'#Ed'#EdOOQO'#Cs'#CsO,lQQO'#EiOOQO'#Ei'#EiO.iQPO'#CwOOQO'#Dx'#DxO0bQQO,58yO%vQPO'#DxO$^QPO,59uO0iQPO'#D`O$^QPO,59xO$^QPO,59|O0wQPO,5:OO&oQPO,5:RO0|QPO,5:TO1RQPO'#DPOOQO,58y,58yO1WQQO1G/{O1hQQO'#EdO1uQQO'#EfOOQO'#Ef'#EfO2PQPO'#EeO2XQPO'#EeO2`QPO,59ZO2eQQO1G.gO2lQQO1G0{OOQO-E7n-E7nOOQO1G/^1G/^OOQO,5:Z,5:ZO2sQPO,5;bOOQO-E7m-E7mO3OQQO,58}O3VQQO'#DvO5SQPO,59`O5XQSO'#EiOOQO'#Ek'#EkO5dQPO'#EjO5lQPO'#EjO5wQPO,59cOOQO'#Cf'#CfOOQO'#Ch'#ChOOQO'#Cj'#CjOOQO'#Cm'#CmO%vQPO,5:dO5|QQO,5:dO6^QPO1G/aOOQO'#Da'#DaO7qQPO,59zOOQO1G/d1G/dOOQO1G/h1G/hO%vQPO1G/jO$^QPO1G/mO7vQPO'#DkO8OQPO1G/oO8TQPO,59kO%vQPO,59[OOQO,5:X,5:XO8YQPO,5;POOQO-E7k-E7kOOQO1G.u1G.uOOQO7+$R7+$RP8bQPO'#DoOOQO1G.i1G.iO8gQPO1G.zO8lQPO,5;VOOQO,5:Y,5:YO8tQPO,5;UOOQO-E7l-E7lOOQO1G.}1G.}O8|QQO1G0OO$^QPO7+${O%vQPO1G/fO9^QQO7+%UOOQO7+%X7+%XO9eQPO,5:VOOQO7+%Z7+%ZOOQO1G/V1G/VO9jQQO'#CrOOQO1G.v1G.vP9tQPO'#DmO9yQPO7+$fOOQO1G0q1G0qP:OQPO'#DnOOQO<<Hg<<HgO:TQQO7+%QOOQO<<Hp<<HpOOQO1G/q1G/qO:[QPO<<HQO:aQPO<<HlO:oQPOAN=lO:tQPOAN>WOOQOG23WG23WOOQOG23rG23rO!aQPO'#EX",
  stateData: ":y~O!gOSPOS~O_QO`QOq_OrfOu^Ov^OwUOxUO{WO!O`O!RaO!VbO!XcO![dO!^eO!kPOyRP~O!kPO~O_gO`gO#`iO#ajO#bjO#cjO#djO#ejO#fjO#gjO#hjO~OUnOWlO_!jX`!jX#`!jX#a!jX#b!jX#c!jX#d!jX#e!jX#f!jX#g!jX#h!jX~OpoOyRX~O_QO`QOq_OrfOu^Ov^OwUOxUO{WO!O`O!RaO!VbO!XcO![dO!kPOyRP~O|rO~P$^OysO~O!kPOy#jP~OU!POWxOZ!SO]!SO_#|O`#|Oi}Oj!OO!kPO!p!SO~OyRX~P%vOWxO~OW!UO~OW![O~OUnOy!jXX!jX~OX#XP~P%vO|!hO~P$^O#Z!iOy#jXX#jX~O!kPOy#jXX#jX~Oy#WX!m#WX!n#WX!o#WX!p#WX!q#WX!r#WX!s#WX!t#WX!u#WX!v#WX!w#WX!x#WX!y#WX!z#WX!|#WX!}#WX#O#WX#P#WX#Q#WX#R#WX#S#WX#T#WX#U#WX#V#WXm#WXX#WX#Z#WX~P#ZO_!jX`!jX!m#WX!n#WX!o#WX!p#WX!q#WX!r#WX!s#WX!t#WX!u#WX!v#WX!w#WX!x#WX!y#WX!z#WX!|#WX!}#WX#O#WX#P#WX#Q#WX#R#WX#S#WX#T#WX#U#WX#V#WX#`!jX#a!jX#b!jX#c!jX#d!jX#e!jX#f!jX#g!jX#h!jXX#WX#Z#WX~Oy#WXm#WX~P){O#[!nOy#]X!m#]X!n#]X!o#]X!p#]X!q#]X!r#]X!s#]X!t#]X!u#]X!v#]X!w#]X!x#]X!y#]X!z#]X!|#]X!}#]X#O#]X#P#]X#Q#]X#R#]X#S#]X#T#]X#U#]X#V#]XX#]X#Z#]Xm#]X~Oi!OOj!oOm#^P~O!m!tO!n!tO!o!uO!p!uO!q!uO!r!uO!s!uO!t!uO!u!vO!v!vO!w!vO!x!vO!y!vO!z!vO!|!wO!}!wO#O!wO#P!wO#Q!wO#R!wO#S!wO#T!wO#U!wO#V!wO~OyRa~P.tO_QO`QO!kPOy!TP~O!Y#PO~OW#RO~Oj#TO~Oy!iiX!ii#Z!iim!ii~P.tOUnOWlOe#UO~P){OX#YX#Z#YX~P.tO#Z#VOX#XX~OX#XX~P%vOX#YO~Om#ZO~P.tOy#ii~P.tO#Z!iOy#jaX#ja~OX#]O~P.tOUnOy!jX!m!jX!n!jX!o!jX!p!jX!q!jX!r!jX!s!jX!t!jX!u!jX!v!jX!w!jX!x!jX!y!jX!z!jX!|!jX!}!jX#O!jX#P!jX#Q!jX#R!jX#S!jX#T!jX#U!jX#V!jXX!jX#Z!jXm!jX~Oi#^O~Ol#_Om#]X#Z#]X~O#Z#`Om#^X~Oi!OOj!oOm#^X~Om#cO~Oy!laX!la#Z!lam!la~P.tO!P#eO_}i`}iq}ir}iu}iv}iw}ix}iy}i{}i!O}i!R}i!V}i!X}i![}i!^}i!e}i!k}i|}i!Y}i~Oy#fO~O!kPOX#jP~O{WO~OX#kO~O#Z#VOX#Xa~O#Z!iO~O#[#oO~Oi!OOj!OO~O#Z#`Om#^a~Oy!liX!li#Z!lim!li~P.tOy#tO~P.tOX#uO~OXfX#ZfX~P.tO#Z#VO~Oi#vO~O#Z#`O~Oy#wO~P.tO#[#xO~O_QO`QO!kPOX!TP~Oi#zO~OX#{O~O",
  goto: ".T#lPPP#m#y$|P%lPP&TP&TP&TPP&T&b'Q'VP'Z'^'^PP'^PP'l'lPPP'o'rPPPPP(OPP(_PP(kP(w(z(kP(kPP(kP)QP)U)X)_)e)k)rPPP)x*d+SP+rPPPPPPPPPPPPPP,fPPPPPPPPPP'^-U-XPP-_-t-wPPPPPPPPP'r-}(_eYOW]cq!T!V!W#Q#ehSOW]cq!T!U!V!W#Q#e#wQhQSu^#Rdy_knox!S!x#P#U#fQ!YdQ!ZeS!_l!cQ!jvR!m#|lTOQW]cq!T!U!V!W#Q#e#w#|iz_klnox!S!c!x#P#U#fh!Q_klnox!S!c!x#P#U#fQ!T`Q!WbR#Q!Yg!x!R!^!`!e!f!l!y#d#g#l#sdVOW]cq!T!V!W#Q#eh{_klnox!S!c!x#P#U#fT!{!U#wVmSy!_T!al!cR#m#Ui!Q_klnox!S!c!x#P#U#fRkRR!]feUOW]cq!T!V!W#Q#edZOW]cq!T!V!W#Q#eR#j#SeZOW]cq!T!V!W#Q#eeXOW]cq!T!V!W#Q#eR!VaQ!|!UR#y#wT[O]R#S!ZQ]ORt]Q!clR#X!cQ!r!PR#b!rSv^#RR!kvQqWR!gqS[O]SpWqQ!XcQ!z!TQ!}!VQ#O!WQ#h#QR#r#edUOW]cq!T!V!W#Q#eh|_klnox!S!c!x#P#U#fT!{!U#w!QROW]_cklnoqx!S!T!U!V!W!c!x#P#Q#U#e#f#wTgQ#|Q!R_Q!^kS!`l!cQ!enQ!foQ!lxQ!y!SQ#d!xQ#g#PQ#l#UR#s#fdUOW]cq!T!V!W#Q#eh!Q_klnox!S!c!x#P#U#fT!{!U#wR!dlQ!blR#W!ch!Q_klnox!S!c!x#P#U#fS!p!P!rR#p#_R!s!PQ!q!PR#a!rQw^R#i#R",
  nodeNames: "⚠ Comment Nasl SimpleInstr Identifier ArrayElem [ ParenExpr ( ) LogicOp ! ArithOp ~ BitOp ++ -- CmpOp FuncCall ArgList NamedArg : Expr Aff IpAddr Integer String ConstArray => ] AssignOp UpdateOp x return include IncExpr VarDecl local_var global_var break continue ; Block { } IfBlock if else ForLoop for ForExpr AffFunc WhileLoop while RepeatLoop repeat until ForeachLoop foreach FuncDecl function ArgDecl",
  maxTerm: 119,
  nodeProps: [
    ["isolate", 1,""]
  ],
  propSources: [highlighting],
  skippedNodes: [0,1],
  repeatNodeCount: 5,
  tokenData: ".t~RrXY#]YZ#]]^#]pq#]qr#nrs$Tst$ruv%^vw%kwx%xxy(]yz(bz{(g{|(||})c}!O)h!O!P)}!P!Q*S!Q![*a![!]*i!]!^*n!^!_*s!_!`+b!`!a,P!c!}-f!}#O-w#P#Q-|#Q#R.R#R#S-f#T#o-f#o#p.W#p#q.]#q#r.j#r#s.o~#bS!g~XY#]YZ#]]^#]pq#]R#sQZP!_!`#y#r#s$OQ$OO#TQQ$TO#PQ~$WTOr$Trs$gs;'S$T;'S;=`$l<%lO$T~$lOj~~$oP;=`<%l$T~$wTP~OY$rZ]$r^;'S$r;'S;=`%W<%lO$r~%ZP;=`<%l$r~%cP!t~!_!`%f~%kO#e~~%pP!u~vw%s~%xO!m~~%{VOw%xwx$gx#O%x#O#P&b#P;'S%x;'S;=`(V<%lO%x~&eZYZ%xrs%xwx%x!Q!R%x#O#P%x#Y#Z%x#b#c%x#f#g%x#h#i%x#j#k%x#l#m'W~'ZSYZ'g!Q!['g!c!i'g#T#Z'g~'jSYZ'v!Q!['v!c!i'v#T#Z'v~'ySYZ%x!Q![%x!c!i%x#T#Z%x~(YP;=`<%l%x~(bOW~~(gOX~~(lQ!q~z{(r!_!`(w~(wO!r~~(|O#c~~)RQ!o~{|)X!_!`)^~)^O_~~)cO#a~~)hO#Z~~)mQ!p~}!O)s!_!`)x~)xO`~~)}O#b~~*SO#[~~*XP!s~!_!`*[~*aO#d~~*fPi~!Q![*a~*nOe~~*sOy~~*xQ#Q~!^!_+O!_!`+]~+TP!z~!_!`+W~+]O#h~~+bO#V~~+gR#`R!_!`+p!`!a+u#r#s+z~+uO#S~S+zOlS~,PO#O~~,US#R~qr,b!^!_,m!_!`,r!`!a,w~,eP!^!_,h~,mO!}~~,rO!|~~,wO#U~~,|Q!x~!_!`-S!`!a-X~-XO#f~~-^P!y~!_!`-a~-fO#g~~-kS!k~!Q![-f!c!}-f#R#S-f#T#o-f~-|OU~~.ROm~~.WO!v~~.]O{~~.bP!w~#p#q.e~.jO!n~~.oO|~~.tO]~",
  tokenizers: [0, 1, 2],
  topRules: {"Nasl":[0,2]},
  specialized: [{term: 73, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 0
});

let props, data, parser, keywords, skipComplete, completionSource;

keywords = [ 'break', 'continue', 'else', 'for', 'foreach', 'function', 'global_var', 'if', 'include',
             'local_var', 'repeat', 'return', 'until', 'while', 'x' ];

skipComplete = [ 'Comment', 'String' ];

completionSource = autocomplete.ifNotIn(skipComplete,
                           autocomplete.completeFromList(keywords.map(kw => ({ label: kw, type: 'keyword' }))));

props = [ language$1.indentNodeProp.add({ 'Block': language$1.delimitedIndent({ closing: '}' }),
                               'ArgDecl ForExpr IncExpr ArgList': language$1.delimitedIndent({ closing: ')',
                                                                                    align: true }),
                               IfBlock: language$1.continuedIndent({ except: /^\s*({|else\b)/ }),
                               WhileLoop: language$1.continuedIndent() }),
          language$1.foldNodeProp.add({ 'Block ArgDecl ArgList': language$1.foldInside }) ];

data = { commentTokens: { line: '#' },
         closeBrackets: { brackets: [ '(', '[', '{', "'", '"' ] },
         indentOnInput: /^\s*(?:\{|\})$/ };

parser = parser$1.configure({ props: props });

/// A language provider for NASL, including highlighting and indentation
/// information.
const lr = language$1.LRLanguage.define({ name: 'NASL',
                               parser: parser,
                               languageData: data });

/// Language support for NASL.
function language
() {
  return new language$1.LanguageSupport(lr,
                             [ lr.data.of({ autocomplete: completionSource }) ])
}

exports.language = language;
exports.lr = lr;
